<template>
  <div class="createSystem">
    <b-button
      variant="success"
      v-b-modal.create-system-modal
      v-show="me && me.groups.includes('MOD')"
    >
      <b-icon-file-plus />
      System
    </b-button>

    <b-modal
      id="create-system-modal"
      title="Create System"
      @ok="submit"
      ok-variant="success"
    >
      <p>Enter some metadata to create the system.</p>
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="name">Name</label>
        <b-form-input
          id="name"
          v-model="name"
          :state="name.length >= 3"
          placeholder="System name"
          trim
        />

        <label for="description">Description</label>
        <b-form-textarea
          id="description"
          v-model="description"
          placeholder="Describe your system..."
          trim
        />

        <label for="image">Image</label>
        <b-form-input
          id="image"
          v-model="image"
          placeholder="Image to illustrate the system"
          trim
        />

        <label for="logLink">Log Link</label>
        <b-form-input
          id="logLink"
          v-model="logLink"
          placeholder="Link to a page that explains testers where to get logs"
          trim
        />

        <label for="buildDiscovery">Build Discovery</label>
        <div id="buildDiscovery">
          <b-form-select
            v-model="discoveryEngine"
            :options="[
              { value: 'gitlab', text: 'GitLab releases' },
              { value: 'github', text: 'GitHub releases' },
              { value: 'openstore', text: 'Ubuntu Touch OpenStore' },
              { value: 'systemimage', text: 'Ubuntu Touch System-Image server' }
            ]"
          />
          <b-form-input
            v-model="discoveryArgs"
            placeholder="Build discovery arguments"
            trim
          />
        </div>
      </b-form>
    </b-modal>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "CreateSystem",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: "",
      description: "",
      logLink: "",
      image: "",
      discoveryEngine: "",
      discoveryArgs: ""
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($system: SystemInput!) {
              createSystem(system: $system) {
                id
              }
            }
          `,
          variables: {
            system: {
              name: this.name,
              description: this.description,
              logLink: this.logLink,
              image: this.image,
              buildDiscovery:
                this.discoveryEngine && this.discoveryArgs
                  ? {
                      engine: this.discoveryEngine,
                      args: this.discoveryArgs.split(", ")
                    }
                  : undefined
            }
          }
        })
        .then(data =>
          this.$router.push({ path: `/system/${data.data.createSystem.id}` })
        )
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
